<?php

/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author        D3 Data Development - Daniel Seifert <ds@shopmodule.com>
 * @link          http://www.oxidmodule.com
 */
class d3_transferform_update extends d3install_updatebase
{

    public $sModKey = 'd3transferform';

    public $sModName = 'Vorkasseassistent';

    public $sModVersion = '3.1.1.0';

    public $sModRevision = '48';

    public $sBaseConf = 'X10czBHdC9GSzJseEJ4MmZyNjFvekxoV3AxeUJwSnp6VUM2aGZnRlRScHV2SmdTQW5GdkljUm5VMUhlU
XdyRmJ6Q2JKZG42cnBtMFZpOHlzWm50Z2tkTk9tVHczdisxV1pJS2NRS1o1WHlmdjJOaTV0Tk0yUXg2S
1M4Qk1Rc3FsMWJ1bXVHNU5BUVowRnVoaWFBcnovcUdlUGZydC9sTXJFdGIrVENBaWx5VHZqblQwOWlXS
E90czMwcVZLdUwwTVBMT3F5Z1dsRmRoVTh2WTFiRExmb2hXUlFPanAyaUdiSXhiL1d0VTdmaXFia2xFR
Udvb3hHUjZkbzFJL0tKeEpFN1Yxd3BVWmVPNlFXanN4QnRuUGJqTlkwTHp4bkhTRndScTFGbkd0RlgvR
lE9';

    public $sRequirements = '<?xml version="1.0" encoding="UTF-8"?>
      <jobs>
        <registerModule>
          <module class="oxemail" modulepath="d3/d3transferform/modules/core/d3_oxemail_payremind" />
          <module class="order_overview" modulepath="d3/d3transferform/modules/controllers/admin/d3_order_overview_payremind" />
        </registerModule>
        <database>
          <table name="oxorder">
            <col name="D3PAYREMINDDATE" type="DATETIME" />
          </table>
        </database>
      </jobs>';

    public $sBaseValue = '';

    protected $_aUpdateMethods = array(
        array(
            'check' => 'checkModCfgItemExist',
            'do'    => 'updateModCfgItemExist'
        ),
        array(
            'check' => 'hasToRenameFields',
            'do'    => 'updateVorkasseinfoRenameFields'
        ),
        array(
            'check' => 'checkVorkasseFields',
            'do'    => 'updateVorkasseinfoFields'
        ),
        array(
            'check' => 'checkUpdateMailContent',   // erst check auf "ist da"
            'do'    => 'updateMailContent'         // wenn ja -> Meldung ausgeben: bitte Manuell Updaten...
        ),
        array(
            'check' => 'checkInsertMailContent',   // danach erneut check auf "ist da"
            'do'    => 'insertMailContent'         // wenn nicht -> Insert
        ),
        array(
            'check' => 'hasOldModuleFiles',
            'do'    => 'deleteOldModuleFiles'
        ),
        array(
            'check' => 'hasUnregisteredFiles',
            'do'    => 'showUnregisteredFiles'
        ),
        array(
            'check' => 'checkModCfgSameRevision',
            'do'    => 'updateModCfgSameRevision'
        ),
    );

    public $aFields = array(
        'D3PAYREMINDDATE' => array(
            'sTableName'  => 'oxorder',
            'sFieldName'  => 'D3PAYREMINDDATE',
            'sType'       => 'DATETIME',
            'blNull'      => false,
            'sDefault'    => '0000-00-00 00:00:00',
            'sComment'    => 'D3 Vorkasseassistent',
            'sExtra'      => '',
            'blMultilang' => false,
        ),
    );

    public $aRenameFields = array(
        'D3PAYREMINDDATE' => array(
            'sTableName'     => 'oxorder',
            'mOldFieldNames' => 'd3reminddate',
            'sFieldName'     => 'D3PAYREMINDDATE',
            'blMultilang'    => false,
            'sComment'       => 'D3 Vorkasseassistent',
        ),
    );

    protected $_aRefreshMetaModuleIds = array('d3transferform');

    public $aOldModuleFiles = array(
        'd3/d3transferform/d3transferform_stub.php',
        'd3/d3transferform/models/d3_transferform_update.php',
    );

    /**
     * @return bool
     */
    public function hasToRenameFields()
    {
        $blRet = $this->checkRenameFields();

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateVorkasseinfoRenameFields()
    {
        return $this->fixRenameFields(__METHOD__);
    }

    /**
     * @return bool
     */
    public function checkVorkasseFields()
    {
        $blRet = false;
        $blRet = $this->checkFields();

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateVorkasseinfoFields()
    {
        return $this->fixFields(__METHOD__);
    }

    /**
     * @return bool
     */
    public function checkModCfgItemExist()
    {
        $blRet = false;
        foreach ($this->getShopList() as $oShop) {
            /** @var $oShop oxshop */
            $aWhere = array(
                'oxmodid'       => $this->sModKey,
                'oxnewrevision' => $this->sModRevision,
                'oxshopid'      => $oShop->getId(),
            );

            $blRet = $this->_checkTableItemNotExist('d3_cfg_mod', $aWhere);

            if ($blRet) {
                return $blRet;
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateModCfgItemExist()
    {
        $blRet = false;

        if ($this->checkModCfgItemExist()) {
            foreach ($this->getShopList() as $oShop) {
                /** @var $oShop oxshop */
                $aWhere = array(
                    'oxmodid'       => $this->sModKey,
                    'oxshopid'      => $oShop->getId(),
                    'oxnewrevision' => $this->sModRevision,
                );

                if ($this->_checkTableItemNotExist('d3_cfg_mod', $aWhere)) {
                    // update don't use this property
                    unset($aWhere['oxnewrevision']);

                    $aInsertFields = array(
                        'OXID'           => array(
                            'content'      => "md5('" . $this->sModKey . " " . $oShop->getId() . " de')",
                            'force_update' => true,
                            'use_quote'    => false,
                        ),
                        'OXSHOPID'       => array(
                            'content'      => $oShop->getId(),
                            'force_update' => true,
                            'use_quote'    => true,
                        ),
                        'OXMODID'        => array(
                            'content'      => $this->sModKey,
                            'force_update' => true,
                            'use_quote'    => true,
                        ),
                        'OXNAME'         => array(
                            'content'      => $this->sModName,
                            'force_update' => true,
                            'use_quote'    => true,
                        ),
                        'OXACTIVE'       => array(
                            'content'      => "0",
                            'force_update' => false,
                            'use_quote'    => false,
                        ),
                        'OXBASECONFIG'   => array(
                            'content'      => $this->sBaseConf,
                            'force_update' => true,
                            'use_quote'    => true,
                        ),
                        'OXSERIAL'       => array(
                            'content'      => "",
                            'force_update' => false,
                            'use_quote'    => true,
                        ),
                        'OXINSTALLDATE'  => array(
                            'content'      => "NOW()",
                            'force_update' => true,
                            'use_quote'    => false,
                        ),
                        'OXVERSION'      => array(
                            'content'      => $this->sModVersion,
                            'force_update' => true,
                            'use_quote'    => true,
                        ),
                        'OXSHOPVERSION'  => array(
                            'content'      => oxRegistry::getConfig()->getEdition(),
                            'force_update' => true,
                            'use_quote'    => true,
                        ),
                        'OXREQUIREMENTS' => array(
                            'content'      => $this->sRequirements,
                            'force_update' => true,
                            'use_quote'    => true,
                        ),
                        'OXVALUE'        => array(
                            'content'      => $this->sBaseValue,
                            'force_update' => false,
                            'use_quote'    => true,
                        ),
                        'OXNEWREVISION'  => array(
                            'content'      => $this->sModRevision,
                            'force_update' => true,
                            'use_quote'    => true,
                        )
                    );
                    $aRet          = $this->_updateTableItem('d3_cfg_mod', $aInsertFields, $aWhere);
                    $blRet         = $aRet['blRet'];

                    $this->setActionLog('SQL', $aRet['sql'], __METHOD__);
                    $this->setUpdateBreak(false);

                    if ($this->getStepByStepMode()) {
                        break;
                    }
                }
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function checkModCfgSameRevision()
    {
        $blRet = $this->_checkModCfgSameRevision($this->sModKey);

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateModCfgSameRevision()
    {
        $blRet = false;

        if ($this->checkModCfgSameRevision($this->sModKey)) {
            $aRet = $this->_updateModCfgSameRevision($this->sModKey);

            $this->setActionLog('SQL', $aRet['sql'], __METHOD__);
            $this->setUpdateBreak(false);
            $blRet = $aRet['blRet'];
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function checkUpdateMailContent()
    {
        $blRet       = false;
        $bSkipUpdate = oxRegistry::getSession()->getVariable('d3_transferform_update_skip_content_update');

        if ($bSkipUpdate == 1) {
            return $blRet;
        }

        foreach ($this->getShopList() as $oShop) {
            /** @var $oShop oxshop */
            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerungsubject',
                'oxshopid' => $oShop->getId(),
            );
            $blRet1 = $this->_checkTableItemNotExist('oxcontents', $aWhere);

            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerung',
                'oxshopid' => $oShop->getId(),
            );
            $blRet2 = $this->_checkTableItemNotExist('oxcontents', $aWhere);

            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerungplain',
                'oxshopid' => $oShop->getId(),
            );
            $blRet3 = $this->_checkTableItemNotExist('oxcontents', $aWhere);

            $blRetX = $this->checkModCfgSameRevision();

            if ((!$blRet1 || !$blRet2 || !$blRet3) && $blRetX) {
                $blRet = true;
            }
        }

        return $blRet;
    }

    /**
     * Message for manuelle Updates for CMS-Site
     *
     * @return bool
     */
    public function updateMailContent()
    {
        $sMessage = 'D3_TRANSFERFORM_UPDATE_ITEM';

        $blRet = $this->_confirmMessage($sMessage);

        oxRegistry::getSession()->setVariable('d3_transferform_update_skip_content_update', 1);

        return $blRet;
    }

    /**
     * @return bool
     */
    public function checkInsertMailContent()
    {
        $blRet = false;

        foreach ($this->getShopList() as $oShop) {
            /** @var $oShop oxshop */
            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerungsubject',
                'oxshopid' => $oShop->getId(),
            );
            $blRet1 = $this->_checkTableItemNotExist('oxcontents', $aWhere);

            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerung',
                'oxshopid' => $oShop->getId(),
            );
            $blRet2 = $this->_checkTableItemNotExist('oxcontents', $aWhere);

            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerungplain',
                'oxshopid' => $oShop->getId(),
            );
            $blRet3 = $this->_checkTableItemNotExist('oxcontents', $aWhere);

            if ($blRet1 || $blRet2 || $blRet3) {
                $blRet = true;
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function insertMailContent()
    {
        $blRet              = false;
        $aExampleJobMethods = array('_addMailSubject', '_addMailHTML', '_addMailPlain');

        foreach ($aExampleJobMethods as $sJobMethod) {
            $blRet = $this->{$sJobMethod}();

        }

        return $blRet;
    }

    /**
     * @param $aWhere
     *
     * @return bool
     */
    protected function _checkInsertContents($aWhere)
    {
        $blRet = $this->_checkTableItemNotExist('oxcontents', $aWhere);

        return $blRet;
    }

    /**
     * @return bool
     */
    public function _addMailSubject()
    {
        $blRet = false;

        foreach ($this->getShopList() as $oShop) {

            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerungsubject',
                'oxshopid' => $oShop->getId(),
            );

            $blNotExist = $this->_checkInsertContents($aWhere);

            if ($blNotExist) {
                $aInsertFields = array(
                    'OXID'      => array(
                        'content'      => "md5('d3zahlungserinnerungsubject " . $oShop->getId() . " de')",
                        'force_update' => true,
                        'use_quote'    => false,
                    ),
                    'OXLOADID'  => array(
                        'content'      => "d3zahlungserinnerungsubject",
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXSHOPID'  => array(
                        'content'      => $oShop->getId(),
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXSNIPPET' => array(
                        'content'      => "1",
                        'force_update' => false,
                        'use_quote'    => false,
                    ),
                    'OXTYPE'    => array(
                        'content'      => "0",
                        'force_update' => false,
                        'use_quote'    => false,
                    ),
                    'OXACTIVE'  => array(
                        'content'       => "1",
                        'force_update'  => true,
                        'use_quote'     => false,
                        'use_multilang' => true,
                    ),
                    'OXTITLE'   => array(
                        'content'       => "E-Mail Zahlungserinnerung Betreff",
                        'force_update'  => false,
                        'use_quote'     => true,
                        'use_multilang' => true,
                    ),
                    'OXCONTENT' => array(
                        'content'       => 'Zahlungserinnerung f�r Bestellung [{$order->oxorder__oxordernr->value}]',
                        'force_update'  => false,
                        'use_quote'     => true,
                        'use_multilang' => true,
                    ),
                    'OXCATID'   => array(
                        'content'      => "039439b35a8846f63.31591365",
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXFOLDER'  => array(
                        'content'      => "CMSFOLDER_EMAILS",
                        'force_update' => true,
                        'use_quote'    => true,
                    )
                );
                $aRet          = $this->_updateTableItem('oxcontents', $aInsertFields, $aWhere);
                $blRet         = $aRet['blRet'];
                $this->setActionLog('SQL', $aRet['sql'], __METHOD__);
                $this->setUpdateBreak(false);
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function _addMailHTML()
    {
        $blRet = false;

        foreach ($this->getShopList() as $oShop) {

            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerung',
                'oxshopid' => $oShop->getId(),
            );

            $blNotExist = $this->_checkInsertContents($aWhere);

            if ($blNotExist) {
                $aInsertFields = array(
                    'OXID'      => array(
                        'content'      => "md5('d3zahlungserinnerung " . $oShop->getId() . " de')",
                        'force_update' => true,
                        'use_quote'    => false,
                    ),
                    'OXLOADID'  => array(
                        'content'      => "d3zahlungserinnerung",
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXSHOPID'  => array(
                        'content'      => $oShop->getId(),
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXSNIPPET' => array(
                        'content'      => "1",
                        'force_update' => false,
                        'use_quote'    => false,
                    ),
                    'OXTYPE'    => array(
                        'content'      => "0",
                        'force_update' => false,
                        'use_quote'    => false,
                    ),
                    'OXACTIVE'  => array(
                        'content'       => "1",
                        'force_update'  => false,
                        'use_quote'     => false,
                        'use_multilang' => true,
                    ),
                    'OXTITLE'   => array(
                        'content'       => "E-Mail Zahlungserinnerung",
                        'force_update'  => false,
                        'use_quote'     => true,
                        'use_multilang' => true,
                    ),
                    'OXCONTENT' => array(
                        'content'       => '<p>Guten Tag [{$order->oxorder__oxbillsal->value|oxmultilangsal}] [{$order->oxorder__oxbillfname->value}] [{$order->oxorder__oxbilllname->value}],</p><br><p>wir m�chten Sie daran erinnern, dass f�r Ihre <strong>Bestellung [{$order->oxorder__oxordernr->value}]</strong> noch keine Zahlung bei uns eingegangen ist.</p><p>Die Ware liegt zum Versand bereit und wird versendet, sobald Ihre �berweisung auf unserem Konto vorliegt.</p><br><p>Ihr [{$shop->oxshops__oxname->value}] Team</p>',
                        'force_update'  => false,
                        'use_quote'     => true,
                        'use_multilang' => true,
                    ),
                    'OXCATID'   => array(
                        'content'      => "8a142c3e4143562a5.46426637",
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXFOLDER'  => array(
                        'content'      => "CMSFOLDER_EMAILS",
                        'force_update' => true,
                        'use_quote'    => true,
                    )
                );
                $aRet          = $this->_updateTableItem('oxcontents', $aInsertFields, $aWhere);
                $blRet         = $aRet['blRet'];
                $this->setActionLog('SQL', $aRet['sql'], __METHOD__);
                $this->setUpdateBreak(false);
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function _addMailPlain()
    {
        $blRet = false;

        foreach ($this->getShopList() as $oShop) {

            $aWhere = array(
                'oxloadid' => 'd3zahlungserinnerungplain',
                'oxshopid' => $oShop->getId(),
            );

            $blNotExist = $this->_checkInsertContents($aWhere);
            if ($blNotExist) {
                $aInsertFields = array(
                    'OXID'      => array(
                        'content'      => "md5('d3zahlungserinnerungplain " . $oShop->getId() . " de')",
                        'force_update' => true,
                        'use_quote'    => false,
                    ),
                    'OXLOADID'  => array(
                        'content'      => "d3zahlungserinnerungplain",
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXSHOPID'  => array(
                        'content'      => $oShop->getId(),
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXSNIPPET' => array(
                        'content'      => "1",
                        'force_update' => false,
                        'use_quote'    => false,
                    ),
                    'OXTYPE'    => array(
                        'content'      => "0",
                        'force_update' => false,
                        'use_quote'    => false,
                    ),
                    'OXACTIVE'  => array(
                        'content'       => "1",
                        'force_update'  => false,
                        'use_quote'     => false,
                        'use_multilang' => true,
                    ),
                    'OXTITLE'   => array(
                        'content'       => "E-Mail Zahlungserinnerung Plain",
                        'force_update'  => false,
                        'use_quote'     => true,
                        'use_multilang' => true,
                    ),
                    'OXCONTENT' => array(
                        'content'       => 'Guten Tag [{$order->oxorder__oxbillsal->value|oxmultilangsal}] [{$order->oxorder__oxbillfname->value}] [{$order->oxorder__oxbilllname->value}],<br><br>wir m�chten Sie daran erinnern, dass f�r Ihre Bestellung [{$order->oxorder__oxordernr->value}] noch keine Zahlung bei uns eingegangen ist. Die Ware liegt zum Versand bereit und wird versendet, sobald Ihre �berweisung auf unserem Konto vorliegt.<br><br><br>Ihr [{$shop->oxshops__oxname->value}] Team',
                        'force_update'  => false,
                        'use_quote'     => true,
                        'use_multilang' => true,
                    ),
                    'OXCATID'   => array(
                        'content'      => "8a142c3e4143562a5.46426637",
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXFOLDER'  => array(
                        'content'      => "CMSFOLDER_EMAILS",
                        'force_update' => true,
                        'use_quote'    => true,
                    )
                );
                $aRet          = $this->_updateTableItem('oxcontents', $aInsertFields, $aWhere);
                $blRet         = $aRet['blRet'];
                $this->setActionLog('SQL', $aRet['sql'], __METHOD__);
                $this->setUpdateBreak(false);
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function hasUnregisteredFiles()
    {
        return $this->_hasUnregisteredFiles($this->sModKey, array('d3FileRegister'));
    }

    /**
     * @return bool
     */
    public function showUnregisteredFiles()
    {
        return $this->_showUnregisteredFiles($this->sModKey, array('d3FileRegister'));
    }
}